
local loopsound = Sound("ambient/levels/labs/teleport_mechanism_windup1.wav")

local mat_rising = Material( "models/shadertest/shader4" )
local mat_sparkle = Material("models/effects/comball_tape")
local top = 80
local mid = 32
local final_height = top

function EFFECT:Init(data)
   self:SetPos(data:GetOrigin())
   self:SetAngles(data:GetAngle())

   self.StartPos = self:GetPos() + Vector(0,0, final_height / 2)

   self.Height = 1

   self.MidTime = CurTime() + data:GetMagnitude()
   self.EndTime = self.MidTime + 1.1

   WorldSound(loopsound, self:GetPos(), 70, 100)
end


function EFFECT:Think()
   if self.EndTime < CurTime() then return end

   if self.MidTime > CurTime() then
      if self.Height < final_height then
         self.Height = self.Height + (45 * FrameTime())
      end

   else
      if self.Height > 1 then
         self.Height = self.Height - (75 * FrameTime())

         local pos = self:GetPos()
         pos.z = pos.z - (75 * FrameTime())
         self:SetPos(pos)
      end

   end

   return true
end

function EFFECT:DrawBox(pos, ang, h, off)

   -- sides
   local w = off * 2
   render.DrawQuadEasy(pos + ang:Forward() * off,
                       ang:Forward(),
                       w, h,
                       COLOR_RED,
                       0)

   render.DrawQuadEasy(pos + ang:Right() * off,
                       ang:Right(),
                       w, h,
                       COLOR_RED,
                       0)

   render.DrawQuadEasy(pos + ang:Right() * -off,
                       -1 * ang:Right(),
                       w, h,
                       COLOR_RED,
                       0)

   render.DrawQuadEasy(pos + ang:Forward() * -off,
                       -1 * ang:Forward(),
                       w, h,
                       COLOR_RED,
                       0)
end

function EFFECT:Render()
   local ang = self:GetAngles()
   render.SetMaterial(mat_sparkle)
   self:DrawBox(self.StartPos, ang, final_height, 17)

   local h = self.Height
   local pos = self:GetPos()
   pos.z = pos.z + final_height - (h / 2)

   render.SetMaterial(mat_rising)
   self:DrawBox(pos, ang, h, 16)

end