
if SERVER then
   AddCSLuaFile("shared.lua")
end

ENT.Type = "anim"
ENT.Base = "ttt_basegrenade_proj"
ENT.Model = Model("models/weapons/w_eq_smokegrenade_thrown.mdl")


AccessorFunc( ENT, "radius", "Radius", FORCE_NUMBER )

function ENT:Initialize()
   if not self:GetRadius() then self:SetRadius(20) end

   return self.BaseClass.Initialize(self)
end

local function randb(n)
   return math.Rand(-n, n)
end

--local smokeparticle = "particle/particle_smokegrenade"
--local smokeparticle = "particle/snow"
local smokeparticle = "particle/sphere"

local smokeparticles = {
   "particle/particle_smokegrenade",
--   "particle/particle_sphere",
   "particle/particle_noisesphere"
};

if CLIENT then
   --precache
   for k, name in pairs(smokeparticles) do
      Material(name)
   end
end

function ENT:CreateSmoke(center)
   local em = ParticleEmitter(center)

   for i=1, 50 do
      local prpos = Vector(randb(self:GetRadius()), randb(self:GetRadius()), randb(self:GetRadius()))
      prpos.z = prpos.z + 32
      local p = em:Add(table.Random(smokeparticles), center + prpos)
      if p then
         local gray = math.random(105, 205)
         p:SetColor(gray, gray, gray)
         p:SetStartAlpha(math.Rand(250, 255))
         p:SetEndAlpha(190)
         p:SetVelocity(VectorRand() * math.Rand(900, 2700))
         p:SetLifeTime(0)
         p:SetDieTime(math.Rand(50, 60))
         p:SetStartSize(math.random(120, 144))
         p:SetEndSize(math.random(80, 110))
         p:SetRoll(math.random(-180, 180))
         p:SetRollDelta(math.Rand(-0.25, 0.25))
         p:SetAirResistance(math.random(500, 600))
         p:SetGravity(Vector(randb(10), randb(10), math.Rand(-20, -45)))
         p:SetCollide(true)
         p:SetBounce(0.4)
         p:SetLighting(0)
      end
   end

   em:Finish()
end

function ENT:Explode(tr)
   if SERVER then
      self.Entity:SetNoDraw(true)
      self.Entity:SetSolid(SOLID_NONE)

      -- pull out of the surface
      if tr.Fraction != 1.0 then
         self.Entity:SetPos(tr.HitPos + tr.HitNormal * 0.6)
      end

      local pos = self.Entity:GetPos()

      self:Remove()
   else
      local spos = self.Entity:GetPos()
      local trs = util.TraceLine({start=spos + Vector(0,0,64), endpos=spos + Vector(0,0,-128), filter=self})
      util.Decal("SmallScorch", trs.HitPos + trs.HitNormal, trs.HitPos - trs.HitNormal)      

      self:SetDetonateExact(0)

      if tr.Fraction != 1.0 then
         spos = tr.HitPos + tr.HitNormal * 0.6
      end

      self:CreateSmoke(spos)      
   end
end