
if SERVER then
   AddCSLuaFile( "shared.lua" )
   
end

SWEP.HoldType			= "slam"

if CLIENT then
   SWEP.PrintName			= "Defuser"
   SWEP.Instructions		= "Defuse C4."
   SWEP.Slot				= 6

   SWEP.ViewModelFOV = 10

   SWEP.EquipMenuData = {
      type="Weapon",
      model="models/weapons/w_defuser.mdl",
      desc="Instantly defuse a C4 explosive.\n\nUnlimited uses. C4 will be easier to\nnotice if you carry this."
   };

   SWEP.Icon = "VGUI/ttt/icon_defuser"
end

SWEP.Base				= "weapon_tttbase"
SWEP.Spawnable			= true
SWEP.AdminSpawnable		= true
SWEP.ViewModel			= "models/weapons/v_crowbar.mdl"
SWEP.WorldModel			= "models/weapons/w_defuser.mdl"
SWEP.Weight			= 5
SWEP.AutoSwitchTo		= false
SWEP.AutoSwitchFrom		= false
SWEP.DrawCrosshair		= true
SWEP.Primary.ClipSize		= -1
SWEP.Primary.DefaultClip	= -1
SWEP.Primary.Automatic		= true
SWEP.Primary.Delay = 1
SWEP.Primary.Ammo		= "none"
SWEP.Secondary.ClipSize		= -1
SWEP.Secondary.DefaultClip	= -1
SWEP.Secondary.Automatic	= true
SWEP.Secondary.Ammo		= "none"
SWEP.Secondary.Delay = 2

SWEP.Kind = WEAPON_EQUIP
SWEP.CanBuy = {ROLE_DETECTIVE} -- only detectives can buy
SWEP.WeaponID = AMMO_DEFUSER


--SWEP.AllowDrop = false

local defuse = Sound("c4.disarmfinish")
function SWEP:PrimaryAttack()
   self.Weapon:SetNextPrimaryFire( CurTime() + self.Primary.Delay )

   local spos = self.Owner:GetShootPos()
   local sdest = spos + (self.Owner:GetAimVector() * 60)

   local tr = util.TraceLine({start=spos, endpos=sdest, filter=self.Owner, mask=MASK_SHOT})

   if IsValid(tr.Entity) and tr.Entity:GetClass() == "ttt_c4" then
      local bomb = tr.Entity
      if bomb:GetArmed() then
         if SERVER then
            bomb:Disarm()
            WorldSound(defuse, bomb:GetPos())
         end

         self.Weapon:SetNextPrimaryFire( CurTime() + (self.Primary.Delay * 2) )
      end
   end
end

function SWEP:SecondaryAttack()
   self.Weapon:SetNextPrimaryFire( CurTime() + self.Primary.Delay )
   self.Weapon:SetNextSecondaryFire( CurTime() + 0.1 )
end


if CLIENT then
   local hudtxt = {text="Click to defuse targeted C4", font="TabLarge", xalign=TEXT_ALIGN_RIGHT}
   function SWEP:DrawHUD()
      hudtxt.pos = {ScrW() - 80, ScrH() - 80}
      draw.Text(hudtxt)
      draw.TextShadow(hudtxt, 2)
   end
end

function SWEP:Reload()
   return false
end

local hidden = false
function SWEP:Deploy()
   hidden = false
   return true
end

--function SWEP:DrawWorldModel()
--end

--function SWEP:DrawWorldModelTranslucent()
--end

-- not able to do DrawModel stuff in Deploy, so here's a hack
function SWEP:Think()
   if SERVER and not hidden and ValidEntity(self.Owner) and self.Owner:GetActiveWeapon() == self.Weapon then
      self.Owner:DrawViewModel(false)
      self.Owner:DrawWorldModel(false)
      hidden = true
   end
end

function SWEP:OnDrop()
   hidden = false
end
