
if SERVER then
   AddCSLuaFile( "shared.lua" )
end

SWEP.HoldType			= "pistol"

if CLIENT then

   SWEP.PrintName			= "Flare gun"
   SWEP.Author				= "TTT"
   SWEP.Slot				= 6
   SWEP.SlotPos			= 0

   SWEP.ViewModelFOV		= 54
   SWEP.ViewModelFlip		= false

   SWEP.EquipMenuData = {
      type="Weapon",
      model="models/weapons/w_357.mdl",
      desc="Can be used to burn corpses so that\nthey are never found. Limited ammo.\n\nBurning a corpse makes a distinct\nsound."
   }


   SWEP.Icon = "VGUI/ttt/icon_flare"
end

SWEP.Base = "weapon_tttbase"
SWEP.Primary.Recoil	= 4
SWEP.Primary.Damage = 5
SWEP.Primary.Delay = 1.0
SWEP.Primary.Cone = 0.01
SWEP.Primary.ClipSize = 4
SWEP.Primary.Automatic = false
SWEP.Primary.DefaultClip = 4
SWEP.Primary.ClipMax = 4

SWEP.Kind = WEAPON_EQUIP
SWEP.CanBuy = {ROLE_TRAITOR} -- only traitors can buy
SWEP.LimitedStock = true -- only buyable once
SWEP.WeaponID = AMMO_FLARE

-- if I run out of ammo types, this weapon is one I could move to a custom ammo
-- handling strategy, because you never need to pick up ammo for it
SWEP.Primary.Ammo = "AR2AltFire"



SWEP.ViewModel			= "models/weapons/v_357.mdl"
SWEP.WorldModel			= "models/weapons/w_357.mdl"

SWEP.Primary.Sound		= Sound( "Weapon_USP.SilencedShot" )

SWEP.Tracer = "AR2Tracer"

-- models\weapons\flare.mdl


function IgniteTarget(att, path, dmginfo)
   if SERVER and path.Hit and path.HitNonWorld and ValidEntity(path.Entity) then
      local ent = path.Entity

      local dur = ent:IsPlayer() and 5 or 10

      ent:Ignite(dur, 100)

      if ent:IsPlayer() then
         ent.ignite_info = {att=dmginfo:GetAttacker(), infl=dmginfo:GetInflictor()}

         timer.Simple(dur + 0.1, function()
                                    if ValidEntity(ent) then
                                       ent.ignite_info = nil
                                    end
                                 end)
      end

      if ent:GetClass() == "prop_ragdoll" then
         local mid = ent:LocalToWorld(ent:OBBCenter())
         mid.z = mid.z + 25
         util.PaintDown(mid, "Scorch", ent)
         SafeRemoveEntityDelayed(ent, 5)
      end
   end
end

function SWEP:ShootFlare()
   local cone = self.Primary.Cone
   local bullet = {}
   bullet.Num       = 1
   bullet.Src       = self.Owner:GetShootPos()
   bullet.Dir       = self.Owner:GetAimVector()
   bullet.Spread    = Vector( cone, cone, 0 )
   bullet.Tracer    = 1
   bullet.Force     = 2
   bullet.Damage    = self.Primary.Damage
   bullet.TracerName = self.Tracer
   bullet.Callback = IgniteTarget
   
   self.Owner:FireBullets( bullet )
end

function SWEP:PrimaryAttack()
   self.Weapon:SetNextPrimaryFire( CurTime() + self.Primary.Delay )

   if not self:CanPrimaryAttack() then return end

   self.Weapon:EmitSound( self.Primary.Sound )

   self.Weapon:SendWeaponAnim( ACT_VM_PRIMARYATTACK )

   self:ShootFlare()

   self:TakePrimaryAmmo( 1 )

   if ValidEntity(self.Owner) then
      self.Owner:SetAnimation( PLAYER_ATTACK1 )

      self.Owner:ViewPunch( Angle( math.Rand(-0.2,-0.1) * self.Primary.Recoil, math.Rand(-0.1,0.1) *self.Primary.Recoil, 0 ) )
   end

   if ( (SinglePlayer() && SERVER) || CLIENT ) then
      self.Weapon:SetNetworkedFloat( "LastShootTime", CurTime() )
   end
end

function SWEP:SecondaryAttack()
end

-- DEBUG
--function SWEP:Reload()
--   return false
--end