
if SERVER then

   AddCSLuaFile( "shared.lua" )
   
end

SWEP.HoldType           = "ar2"

if CLIENT then
   
   SWEP.PrintName          = "Rifle"           
   SWEP.Author             = "TTT"
   SWEP.Slot               = 2
   SWEP.SlotPos            = 1
   SWEP.IconLetter         = "w"
   SWEP.Icon = "VGUI/ttt/icon_scout"    
end


SWEP.Base               = "weapon_tttbase"
SWEP.Spawnable = true
SWEP.AdminSpawnable = true

SWEP.Kind = WEAPON_HEAVY
SWEP.WeaponID = AMMO_RIFLE

SWEP.Primary.Delay          = 1.5
SWEP.Primary.Recoil         = 7
SWEP.Primary.Automatic = true
SWEP.Primary.Ammo = "357"
SWEP.Primary.Damage = 40 -- not an accurate reflection of in-game damage, sadly
SWEP.Primary.Cone = 0.005
SWEP.Primary.ClipSize = 10
SWEP.Primary.ClipMax = 20 -- keep mirrored to ammo
SWEP.Primary.DefaultClip = 10
SWEP.AutoSpawnable      = true
SWEP.AmmoEnt = "item_ammo_357_ttt"
SWEP.ViewModel          = "models/weapons/v_snip_scout.mdl"
SWEP.WorldModel         = "models/weapons/w_snip_scout.mdl"

SWEP.Primary.Sound = Sound("weapons/scout/scout_fire-1.wav")
--SWEP.Primary.Sound            = Sound( "Weapon_Scout.Single" )

--SWEP.IronSightsPos        = Vector( 5, 0, 1 )
SWEP.IronSightsPos      = Vector( 5, -15, -2 )
SWEP.IronSightsAng      = Vector( 2.6, 1.37, 3.5 )

function SWEP:SetZoom(state)
    if CLIENT then 
       return
    else
       if state then
          self.Owner:SetFOV(20, 0.3)
       else
          self.Owner:SetFOV(0, 0.2)
       end
    end
end

-- Add some zoom to ironsights for this gun
function SWEP:SecondaryAttack()

    if not self.IronSightsPos then return end
    if self.Weapon:GetNextSecondaryFire() > CurTime() then return end
    
    bIronsights = not self.Weapon:GetNetworkedBool( "Ironsights", false )
    
    self:SetIronsights( bIronsights )
    
    if SERVER then
        self:SetZoom(bIronsights)
    end
    
    self.Weapon:SetNextSecondaryFire( CurTime() + 0.3)
    
end

function SWEP:PreDrop()
    self:SetZoom(false)
    self:SetIronsights(false)
    return self.BaseClass.PreDrop(self)
end

function SWEP:Reload()
    self.Weapon:DefaultReload( ACT_VM_RELOAD );
    self:SetIronsights( false )
    self:SetZoom(false)
end


function SWEP:Holster()
    self:SetIronsights(false)
    self:SetZoom(false)
    return true
end

if CLIENT then
--   local scopearc = surface.GetTextureID("sprites/scope_arc")
--   local scopemat = Material("sprites/scope_arc")
--
   function SWEP:DrawHUD()
      if self.Weapon:GetNetworkedBool( "Ironsights" ) then
--         local wh = math.ceil(ScrW() / 2)
--         local hh = math.ceil(ScrH() / 2)
--         local wo = math.ceil(wh / 2)
--         local ho = math.ceil(hh / 2)
--
--         local fix = math.floor(ho / 100)

         surface.SetDrawColor( 0, 0, 0, 255 )
         
         local x = ScrW() / 2.0
         local y = ScrH() / 2.0

         local gap = 140
         local length = 320
         surface.DrawLine( x - length, y, x - gap, y )
         surface.DrawLine( x + length, y, x + gap, y )
         surface.DrawLine( x, y - length, x, y - gap )
         surface.DrawLine( x, y + length, x, y + gap )

         gap = 42
         length = 120
         surface.DrawLine( x - length, y, x - gap, y )
         surface.DrawLine( x + length, y, x + gap, y )
         surface.DrawLine( x, y - length, x, y - gap )
         surface.DrawLine( x, y + length, x, y + gap )

         surface.SetDrawColor(255, 255, 255, 255)

         gap = 2
         length = 10
         surface.DrawLine( x - length, y, x - gap, y )
         surface.DrawLine( x + length, y, x + gap, y )
         surface.DrawLine( x, y - length, x, y - gap )
         surface.DrawLine( x, y + length, x, y + gap )
         
         return
      end


      return self.BaseClass.DrawHUD(self)
   end

end