---- Trouble in Terrorist Town

AddCSLuaFile("cl_init.lua")
AddCSLuaFile("shared.lua")
AddCSLuaFile("cl_hud.lua")
AddCSLuaFile("cl_msgstack.lua")
AddCSLuaFile("cl_hudpickup.lua")
AddCSLuaFile("cl_keys.lua")
AddCSLuaFile("cl_wepswitch.lua")
AddCSLuaFile("cl_awards.lua")
AddCSLuaFile("cl_scoring.lua")
AddCSLuaFile("cl_popups.lua")
AddCSLuaFile("cl_equip.lua")
AddCSLuaFile("cl_help.lua")
AddCSLuaFile("cl_scoreboard.lua")
AddCSLuaFile("cl_tips.lua")
AddCSLuaFile("cl_tips_text.lua")
AddCSLuaFile("cl_voice.lua")
AddCSLuaFile("scoring_shd.lua")
AddCSLuaFile("util.lua")
AddCSLuaFile("player_ext_shd.lua")
AddCSLuaFile("cl_radio.lua")
AddCSLuaFile("cl_radar.lua")
AddCSLuaFile("cl_disguise.lua")
AddCSLuaFile("cl_search.lua")
AddCSLuaFile("cl_targetid.lua")
AddCSLuaFile("vgui/SimpleIcon.lua")
AddCSLuaFile("vgui/ProgressBar.lua")
AddCSLuaFile("vgui/ScrollLabel.lua")
AddCSLuaFile("vgui/sb_main.lua")
AddCSLuaFile("vgui/sb_row.lua")
AddCSLuaFile("vgui/sb_team.lua")
AddCSLuaFile("vgui/sb_info.lua")

include("resources.lua")
include("shared.lua")

include("karma.lua")
include("entity.lua")
include("scoring_shd.lua")
include("radar.lua")
include("traitor_state.lua")
include("propspec.lua")
include("weaponry.lua")
include("gamemsg.lua")
include("ent_replace.lua")
include("scoring.lua")
include("player_ext_shd.lua")
include("player_ext.lua")
include("player.lua")

CreateConVar("ttt_roundtime_minutes", "10", FCVAR_NOTIFY)
CreateConVar("ttt_preptime_seconds", "30", FCVAR_NOTIFY)
CreateConVar("ttt_posttime_seconds", "30", FCVAR_NOTIFY)

local ttt_haste = CreateConVar("ttt_haste", "0", FCVAR_NOTIFY)
CreateConVar("ttt_haste_starting_minutes", "5", FCVAR_NOTIFY)
CreateConVar("ttt_haste_minutes_per_death", "0.5", FCVAR_NOTIFY)

CreateConVar("ttt_spawn_wave_interval", "0")

CreateConVar("ttt_traitor_pct", "0.25", FCVAR_NOTIFY)
CreateConVar("ttt_traitor_max", "32")

CreateConVar("ttt_detective_pct", "0.13", FCVAR_NOTIFY)
CreateConVar("ttt_detective_max", "32")
CreateConVar("ttt_detective_min_players", "8")
CreateConVar("ttt_detective_karma_min", "600")


-- Traitor credits
CreateConVar("ttt_credits_starting", "1")
CreateConVar("ttt_credits_award_pct", "0.35")
CreateConVar("ttt_credits_award_size", "1")
CreateConVar("ttt_credits_award_repeat", "1")
CreateConVar("ttt_credits_detectivekill", "1")


-- Detective credits
CreateConVar("ttt_det_credits_starting", "1")
CreateConVar("ttt_det_credits_traitorkill", "0")
CreateConVar("ttt_det_credits_traitordead", "1")


CreateConVar("ttt_announce_deaths", "1", FCVAR_ARCHIVE + FCVAR_NOTIFY)

CreateConVar("ttt_use_weapon_spawn_scripts", "1")

CreateConVar("ttt_always_use_mapcycle", "0")

CreateConVar("ttt_round_limit", "6", FCVAR_NOTIFY + FCVAR_REPLICATED)
CreateConVar("ttt_time_limit_minutes", "75", FCVAR_NOTIFY + FCVAR_REPLICATED)

CreateConVar("ttt_idle_limit", "180", FCVAR_NOTIFY)

local ttt_detective = CreateConVar("ttt_sherlock_mode", "1", FCVAR_ARCHIVE + FCVAR_NOTIFY)
local ttt_minply = CreateConVar("ttt_minimum_players", "2", FCVAR_ARCHIVE + FCVAR_NOTIFY)

-- debuggery
local ttt_dbgwin = CreateConVar("ttt_debug_preventwin", "0")

-- Localise stuff we use often. It's like Lua go-faster stripes.
local math = math
local table = table
local umsg = umsg
local player = player
local timer = timer

---- Round mechanics
function GM:Initialize()
   MsgN("Trouble In Terrorist Town gamemode initializing...")
   ShowVersion()

   -- Force friendly fire to be enabled. If it is off, we do not get lag compensation.
   RunConsoleCommand("mp_friendlyfire", "1")

   -- Default crowbar unlocking settings, may be overridden by config entity
   GAMEMODE.crowbar_unlocks = {
      [OPEN_DOOR] = true,
      [OPEN_ROT] = true,
      [OPEN_BUT] = true,
      [OPEN_NOTOGGLE]= true
   };

   -- More map config ent defaults
   GAMEMODE.force_plymodel = ""
   GAMEMODE.propspec_allow_named = true

   GAMEMODE.MapWin = WIN_NONE
   GAMEMODE.AwardedCredits = false
   GAMEMODE.AwardedCreditsDead = 0

   GAMEMODE.DamageLog = {}

   -- Initialize game state that is synced with client
   SetGlobalFloat("ttt_round_end", -1)
   SetGlobalFloat("ttt_haste_end", -1)
   SetGlobalBool("ttt_detective", ttt_detective:GetBool())
   SetGlobalBool("ttt_haste", ttt_haste:GetBool())
   SetGlobalInt("ttt_rounds_played", 0)
   SetGlobalInt("ttt_idle_limit", GetConVar("ttt_idle_limit"):GetInt())
   SetGlobalBool("ttt_adminhl", true)

   KARMA.InitState()

   GAMEMODE.playermodel = GetRandomPlayerModel()

   -- For the paranoid
   math.randomseed(os.time())

   WaitForPlayers()
   GameMsg("GAME HAS LOADED, WAITING FOR PLAYERS...")

   -- Show some warnings in common cases of bad server configuration
   if ttt_detective:GetBool() and not server_settings.Bool("sv_scriptenforcer", false) then
      ErrorNoHalt("WARNING: ttt_sherlock_mode is enabled, but sv_scriptenforcer appears to be off. This will make cheating really easy!\n")
   end

   if not table.HasValue(GetMountedContent(), "cstrike") then
      ErrorNoHalt("WARNING: CS:S does not appear to be mounted by GMod. Things may break in strange ways. Server admin? Check the TTT readme for help.\n")
   end

end

function SendRoundState(state, ply)
   if ply then
      umsg.Start("round_state", ply)
   else
      umsg.Start("round_state")
   end
   umsg.Char(state)
   umsg.End()
end

-- Round state is encapsulated by set/get so that it can easily be changed to
-- eg. a networked var if this proves more convenient
function SetRoundState(state)
   GAMEMODE.round_state = state
   
   SCORE:RoundStateChange(state)

   SendRoundState(state)
end

function GetRoundState()
   return GAMEMODE.round_state
end

function EnoughPlayers()
   return #player.GetAll() >= ttt_minply:GetInt()
end

-- Used to be in Think/Tick, now in a timer
function WaitingForPlayersChecker()
   if GetRoundState() == ROUND_WAIT then
      if EnoughPlayers() then
         timer.Create("wait2prep", 1, 1, PrepareRound)

         timer.Stop("waitingforply")
      end
   end
end

-- Start waiting for players
function WaitForPlayers()
   SetRoundState(ROUND_WAIT)

   if not timer.Start("waitingforply") then
      timer.Create("waitingforply", 2, 0, WaitingForPlayersChecker)
   end
end

-- When a player initially spawns after mapload, everything is a bit strange;
-- just making him spectator for some reason does not work right. Therefore,
-- we regularly check for these broken spectators while we wait for players
-- and immediately fix them.
function FixSpectators()
   for k, ply in pairs(player.GetAll()) do
      if ply:IsSpec() and not ply:GetRagdollSpec() and ply:GetMoveType() < MOVETYPE_NOCLIP then
         ply:Spectate(OBS_MODE_ROAMING)
      end
   end
end

-- Used to be in think, now a timer
function WinChecker()
   if GetRoundState() == ROUND_ACTIVE then
      if CurTime() > GetGlobalFloat("ttt_round_end", 0) then
         EndRound(WIN_TIMELIMIT)
      else
         local win = CheckForWin()
         if win != WIN_NONE then
            Msg("Checked for win at " .. CurTime() .. " and there is a winner ("..win..")\n")
            EndRound(win)
            return
         end
      end
   end
end

function StartWinChecks()
   if not timer.Start("winchecker") then
      timer.Create("winchecker", 1, 0, WinChecker)
   end
end

function StopWinChecks()
   timer.Stop("winchecker")
end

local function CleanUp()
   -- if we are going to import entities, it's no use replacing HL2DM ones as
   -- soon as they spawn, because they'll be removed anyway
   SetReplaceChecking(not CanImportEntities(game.GetMap()))

   FixRopesPreCleanup()

   game.CleanUpMap()

   FixRopesPostCleanup()

   -- Strip players now, so that their weapons are not seen by ReplaceEntities
   for k,v in pairs(player.GetAll()) do
      if IsValid(v) then
         v:StripWeapons()
      end
   end

   -- a different kind of cleanup
   util.UnbridledHateForULX()
end

local function SpawnEntities()
   -- Spawn weapons from script if there is one
   local import = CanImportEntities(game.GetMap())

   if import then
      ProcessImportScript(game.GetMap())
   else
      -- Replace HL2DM/ZM ammo/weps with our own
      ReplaceEntities()

      -- Populate CS:S/TF2 maps with extra guns
      PlaceExtraWeapons()
   end

   -- Finally, get players in there
   SpawnWillingPlayers()
end

function PrepareRound()
   -- Check playercount
   if not EnoughPlayers() then
      GameMsg("NOT ENOUGH PLAYERS TO START A NEW ROUND...")
--      SetRoundState(ROUND_WAIT)
      WaitForPlayers()
      return
   end

   if GetGlobalBool("InContinueVote", false) then
      GAMEMODE:FinishContinueVote() -- may start a gamemode vote
   end

   if GAMEMODE:InGamemodeVote() then
      GameMsg("GAMEMODE VOTE IN PROGRESS, DELAYING NEW ROUND BY 30 SECONDS...")
      timer.Create("delayedprep", 30, 1, PrepareRound)
      return
   end

   --GameMsg("CLEANING UP THE MAP FOR A NEW ROUND...")

   -- Cleanup
   CleanUp()

   GAMEMODE.MapWin = WIN_NONE
   GAMEMODE.AwardedCredits = false
   GAMEMODE.AwardedCreditsDead = 0

   SCORE:Reset()

   -- Update damage scaling
   KARMA.RoundBegin()

   -- New look. Random if no forced model set.
   GAMEMODE.playermodel = GAMEMODE.force_plymodel == "" and GetRandomPlayerModel() or GAMEMODE.force_plymodel

   -- Schedule round start
   local ptime = GetConVar("ttt_preptime_seconds"):GetInt()
   timer.Create("prep2begin", ptime, 1, BeginRound)

   -- Mute for a second around traitor selection, to counter a dumb exploit
   -- related to traitor's mics cutting off for a second when they're selected.
   timer.Create("selectmute", ptime - 1, 1, MuteForRestart, true)

   GameMsg("A NEW ROUND BEGINS IN " .. ptime .. " SECONDS. PREPARE YOURSELF.")
   SetRoundState(ROUND_PREP)

   -- Delay spawning until next frame to avoid ent overload
   timer.Simple(0.01, SpawnEntities)

   -- Undo the roundrestart mute, though they will once again be muted for the
   -- selectmute timer.
   timer.Create("restartmute", 1, 1, MuteForRestart, false)

   BroadcastLua("ClearClientState()")

   -- In case client's cleanup fails, make client set all players to innocent role
   timer.Simple(1, SendRoleReset)

   hook.Call("TTTPrepareRound")
end

function SetRoundEnd(endtime)
   SetGlobalFloat("ttt_round_end", endtime)
end

function IncRoundEnd(incr)
   SetRoundEnd(GetGlobalFloat("ttt_round_end", 0) + incr)
end

function TellTraitorsAboutTraitors()
   local traitornicks = {}
   for k,v in pairs(player.GetAll()) do
      if v:IsTraitor() then
         table.insert(traitornicks, v:Nick())
      end
   end

   -- This is ugly as hell, but it's kinda nice to filter out the names of the
   -- traitors themselves in the messages to them
   for k,v in pairs(player.GetAll()) do
      if v:IsTraitor() then
         if #traitornicks < 2 then
            TraitorMsg(v, "TRAITOR, YOU STAND ALONE.")
            return
         else
            local names = ""
            for i,name in pairs(traitornicks) do
               if name != v:Nick() then
                  names = names .. name .. ", "
               end
            end
            names = string.sub(names, 1, -3)
            TraitorMsg(v, "TRAITOR, THESE ARE YOUR ALLIES: " .. names)
         end
      end
   end
end


function SpawnWillingPlayers(dead_only)
   local plys = player.GetAll()
   local wave_delay = GetConVar("ttt_spawn_wave_interval"):GetFloat()

   -- simple method, should make this a case of the other method once that has
   -- been tested.
   if wave_delay <= 0 or dead_only then
      for k, ply in pairs(player.GetAll()) do
         if IsValid(ply) then
            ply:SpawnForRound(dead_only)
         end
      end
   else
      -- wave method
      local num_spawns = #GetSpawnEnts()

      local to_spawn = {}
      for _, ply in RandomPairs(plys) do
         if IsValid(ply) and ply:ShouldSpawn() then
            table.insert(to_spawn, ply)
            GAMEMODE:PlayerSpawnAsSpectator(ply)
         end
      end

      local sfn = function()
                     local c = 0
                     while c < num_spawns and #to_spawn > 0 do
                        for k, ply in pairs(to_spawn) do
                           if IsValid(ply) then
                              if ply:SpawnForRound() then
                                 c = c + 1
                                 table.remove(to_spawn, k)
                              end
                           end

                           if c >= num_spawns then
                              break
                           end
                        end
                     end

                     MsgN("Spawned " .. c .. " in spawn wave.")

                     if #to_spawn == 0 then
                        timer.Destroy("spawnwave")
                        MsgN("Spawn waves ending, all players spawned.")
                     end
                  end

      MsgN("Spawn waves starting.")
      timer.Create("spawnwave", wave_delay, 0, sfn)

      -- already run one wave, which may stop the timer if everyone is spawned
      -- in one go
      sfn()
   end
end

local function StopRoundTimers()
   -- remove all timers
   timer.Stop("wait2prep")
   timer.Stop("prep2begin")
   timer.Stop("end2begin")
   timer.Stop("winchecker")
end

function BeginRound()
   SetGlobalBool("ttt_detective", ttt_detective:GetBool())
   SetGlobalBool("ttt_haste", ttt_haste:GetBool())

   -- Make sure we have the players to do a round, people can leave during prep
   if not EnoughPlayers() then
      GameMsg("NOT ENOUGH PLAYERS TO START A NEW ROUND...")
      StopRoundTimers()
--      SetRoundState(ROUND_WAIT)
      WaitForPlayers()
      return
   end

   AnnounceVersion()

   -- Init round values
   --GAMEMODE.round_start = CurTime()
   local endtime = CurTime() + (GetConVar("ttt_roundtime_minutes"):GetInt() * 60)
   if HasteMode() then
      endtime = CurTime() + (GetConVar("ttt_haste_starting_minutes"):GetInt() * 60)
      SetGlobalFloat("ttt_haste_end", endtime)
   end

   SetRoundEnd(endtime)

   -- Respawn dumb people who died during prep
   SpawnWillingPlayers(true)

   -- Remove their ragdolls
   RemoveRagdolls(true)

   -- Select traitors & co
   SelectRoles()


   GameMsg("THE TRAITORS HAVE BEEN SELECTED.")
   SendFullStateUpdate()

   -- Edge case where a player joins just as the round starts and is picked as
   -- traitor, but for whatever reason does not get the traitor state msg. So
   -- re-send after a second just to make sure everyone is getting it.
   timer.Simple(1, SendFullStateUpdate)


   SCORE:HandleSelection() -- log traitors and detectives

   timer.Simple(1.5, TellTraitorsAboutTraitors)

   -- Give the status messages ample time to arrive
   timer.Simple(2.5, ShowRoundStartPopup)

   -- Start the win condition check timer
   StartWinChecks()

   timer.Create("selectmute", 1, 1, MuteForRestart, false)

   GAMEMODE.DamageLog = {}

   -- Sound start alarm
   SetRoundState(ROUND_ACTIVE)
   GameMsg("THE ROUND HAS BEGUN!")

   ServerLog("Round proper has begun...\n")

   hook.Call("TTTBeginRound")
end

local function ShouldMapSwitch()
   return (not GetConVar("fretta_voting"):GetBool()) or GetConVar("ttt_always_use_mapcycle"):GetBool()
end

function EndRound(type)
   ServerLog("Round ended.\n")

   if type == WIN_TIMELIMIT then
      GameMsg("TIME HAS RUN OUT. THE TRAITORS LOSE.")
      ServerLog("Result: timelimit reached, traitors lose.")
   elseif type == WIN_TRAITOR then
      GameMsg("THE TRAITORS HAVE WON!")
      ServerLog("Result: traitors win.")
   elseif type == WIN_INNOCENT then
      GameMsg("THE TRAITORS HAVE BEEN DEFEATED!")
      ServerLog("Result: innocent win.")
   else
      GameMsg("SOMETHING HAPPENED! THE ROUND IS OVER!")
      ServerLOG("Result: unknown victory condition!")
   end

   -- first handle round end
   SetRoundState(ROUND_POST)

   local ptime = math.max(5, GetConVar("ttt_posttime_seconds"):GetInt())
   GameMsg("LET'S LOOK AT THE ROUND REPORT FOR " .. ptime .. " SECONDS.")
   timer.Create("end2prep", ptime, 1, PrepareRound)

   timer.Create("restartmute", ptime - 1, 1, MuteForRestart, true)

   -- Stop checking for wins
   StopWinChecks()

   -- Check for mapswitch
   local rounds_played = GetGlobalInt("ttt_rounds_played", 0) + 1
   SetGlobalInt("ttt_rounds_played", rounds_played)

   local rounds_left = math.max(0, GetConVar("ttt_round_limit"):GetInt() - rounds_played)
   local time_left = math.max(0, (GetConVar("ttt_time_limit_minutes"):GetInt() * 60) - CurTime())
   local switchmap = false
   local nextmap = string.upper(game.GetMapNext())

   if ShouldMapSwitch() then
      if rounds_left <= 0 then
         GameMsg("ROUND LIMIT REACHED. ".. nextmap .." LOADING SOON.")
         switchmap = true
      elseif time_left <= 0 then
         GameMsg("TIME LIMIT REACHED. ".. nextmap .. " LOADING SOON.")
         switchmap = true
      end
   else
      if rounds_left <= 0 or time_left <= 0 then
         local text = "ROUND OR TIME LIMIT REACHED, BUT MAPCYCLE IS DISABLED."
         if GetConVar("fretta_voting"):GetBool() then
            text = text .. " USE A GAMEMODE VOTE TO SWITCH MAPS."
         end

         GameMsg(text)
      end
   end


   if switchmap then
      timer.Stop("end2prep")
      timer.Simple(15, game.LoadNextMap)
   elseif ShouldMapSwitch() then
      local rtext = rounds_left > 1 and "ROUNDS" or "ROUND"
      GameMsg(rounds_left .. " " .. rtext .. " OR " .. math.ceil(time_left / 60) .. " MINUTES REMAINING BEFORE MAP CHANGES TO " .. nextmap)
   end

   -- Show unobtrusive vote window (only if fretta voting enabled)
   GAMEMODE:StartContinueVote()
   
   KARMA.RoundEnd()

   -- now handle potentially error prone scoring stuff

   -- register an end of round event
   SCORE:RoundComplete(type)

   -- update player scores
   SCORE:ApplyEventLogScores()

   -- send the clients the round log, players will be shown the report
   SCORE:StreamToClients()

   -- server plugins might want to start a map vote here or something
   -- these hooks are not used by TTT internally
   hook.Call("TTTEndRound")
end

function GM:MapTriggeredEnd(wintype)
   self.MapWin = wintype
end

-- The most basic win check is whether both sides have one dude alive
function CheckForWin()
   if ttt_dbgwin:GetBool() then return WIN_NONE end

   if GAMEMODE.MapWin == WIN_TRAITOR or GAMEMODE.MapWin == WIN_INNOCENT then
      local mw = GAMEMODE.MapWin
      GAMEMODE.MapWin = WIN_NONE
      return mw
   end

   local traitor_alive = false
   local innocent_alive = false
   for k,v in pairs(player.GetAll()) do
      if v:Alive() and v:IsTerror() then
         if v:GetTraitor() then
            traitor_alive = true
         else
            innocent_alive = true
         end
      end

      if traitor_alive and innocent_alive then
         return WIN_NONE --early out
      end
   end

   if traitor_alive and not innocent_alive then
      return WIN_TRAITOR
   elseif not traitor_alive and innocent_alive then
      return WIN_INNOCENT
   elseif not innocent_alive then
      -- ultimately if no one is alive, traitors win
      return WIN_TRAITOR
   end
   
   return WIN_NONE
end

function GetTraitorCount(ply_count)
   -- get number of traitors: pct of players rounded down
   local traitor_count = math.floor(ply_count * GetConVar("ttt_traitor_pct"):GetFloat())
   -- make sure there is at least 1 traitor
   traitor_count = math.Clamp(traitor_count, 1, GetConVar("ttt_traitor_max"):GetInt())

   return traitor_count
end


function GetDetectiveCount(ply_count)
   if ply_count < GetConVar("ttt_detective_min_players"):GetInt() then return 0 end

   local det_count = math.floor(ply_count * GetConVar("ttt_detective_pct"):GetFloat())
   -- limit to a max   
   det_count = math.Clamp(det_count, 1, GetConVar("ttt_detective_max"):GetInt())

   return det_count
end


function SelectRoles()
   local choices = {}
   local prev_roles = {
      [ROLE_INNOCENT] = {},
      [ROLE_TRAITOR] = {},
      [ROLE_DETECTIVE] = {}
   };
   for k,v in pairs(player.GetAll()) do
      -- everyone on the spec team is in specmode
      if IsValid(v) and (not v:IsSpec()) then
         -- save previous role and sign up as possible traitor/detective
         table.insert(prev_roles[v:GetRole() or ROLE_INNOCENT], v)

         table.insert(choices, v)
      end

      v:SetRole(ROLE_INNOCENT)
   end

   -- determine how many of each role we want
   local choice_count = #choices
   local traitor_count = GetTraitorCount(choice_count)
   local det_count = GetDetectiveCount(choice_count)

   -- first select traitors
   local ts = 0
   while ts < traitor_count do
      -- select random index in choices table
      local pick = math.random(1, #choices)

      -- the player we consider
      local pply = choices[pick]

      -- make this guy traitor if he was not a traitor last time, or if he makes
      -- a roll
      if (not table.HasValue(prev_roles[ROLE_TRAITOR], pply)) or (math.random(1, 3) == 2) then
         pply:SetRole(ROLE_TRAITOR)

         table.remove(choices, pick)
         ts = ts + 1
      end
   end

   -- now select detectives, explicitly choosing from players who did not get
   -- traitor, so becoming detective does not mean you lost a chance to be
   -- traitor
   local ds = 0
   local min_karma = GetConVarNumber("ttt_detective_min_karma") or 0
   while ds < det_count do
      local pick = math.random(1, #choices)
      local pply = choices[pick]

      -- we are less likely to be a detective unless we were innocent last round
      if ((pply:GetBaseKarma() > min_karma and
           table.HasValue(prev_roles[ROLE_INNOCENT], pply)) or
          math.random(1,4) == 2) then
         pply:SetRole(ROLE_DETECTIVE)

         table.remove(choices, pick)
         ds = ds + 1
      end
   end

   -- initialize credit count for everyone based on their role
   for _, ply in pairs(player.GetAll()) do
      ply:SetDefaultCredits()
   end
end


function ForceRoundRestart(ply, command, args)
   -- ply is nil on dedicated server console
   if (not IsValid(ply)) or ply:IsAdmin() or ply:IsSuperAdmin() or server_settings.Bool("sv_cheats", 0) then
      GameMsg("THE ROUND HAS BEEN FORCED TO RESTART BY WAY OF THE CONSOLE.")

      StopRoundTimers()

      -- do prep
      PrepareRound()
   else
      ply:PrintMessage(HUD_PRINTCONSOLE, "You must be a GMod Admin or SuperAdmin on the server to use this command, or sv_cheats must be enabled.")
   end
end
concommand.Add("ttt_roundrestart", ForceRoundRestart)

function ShowVersion(ply)
   local text = Format("This is TTT version %s (%s)\n", GAMEMODE.Version, GAMEMODE.VerboseVersion)
   if ValidEntity(ply) then
      ply:PrintMessage(HUD_PRINTNOTIFY, text)
   else
      Msg(text)
   end
end
concommand.Add("ttt_version", ShowVersion)

function AnnounceVersion()
   local text = Format("You are playing %s, version %s (%s).\n", GAMEMODE.Name, GAMEMODE.Version, GAMEMODE.VerboseVersion)

   -- announce to players
   for k, ply in pairs(player.GetAll()) do
      if ValidEntity(ply) then
         ply:PrintMessage(HUD_PRINTTALK, text)
      end
   end
end



