-- Altered version of gmod's SpawnIcon
-- This panel does not deal with models and such


local matHover = Material( "vgui/spawnmenu/hover" )

local PANEL = {}

AccessorFunc( PANEL, "m_iIconSize",         "IconSize" )

function PANEL:Init()

   self.Icon = vgui.Create( "DImage", self )
   self.Icon:SetMouseInputEnabled( false )
   self.Icon:SetKeyboardInputEnabled( false )
   
   self.animPress = Derma_Anim( "Press", self, self.PressedAnim )
   
   self:SetIconSize(64)
end

function PANEL:OnMousePressed( mcode )
   if mcode == MOUSE_LEFT then
      self:DoClick()
      self.animPress:Start( 0.2 )
   end
end

function PANEL:OnMouseReleased()
end

function PANEL:DoClick()
end

function PANEL:OpenMenu()
end

function PANEL:ApplySchemeSettings()
end

function PANEL:OnCursorEntered()
   self.PaintOverOld = self.PaintOver
   self.PaintOver = self.PaintOverHovered
end

function PANEL:OnCursorExited()
   if self.PaintOver == self.PaintOverHovered then
      self.PaintOver = self.PaintOverOld
   end
end

function PANEL:PaintOverHovered()

   if self.animPress:Active() then return end

   surface.SetDrawColor( 255, 255, 255, 255 )
   surface.SetMaterial( matHover )
   self:DrawTexturedRect()

end

function PANEL:PerformLayout()

   self:SetSize( self.m_iIconSize, self.m_iIconSize )   
   self.Icon:StretchToParent( 0, 0, 0, 0 )

end

function PANEL:SetIcon( icon )
   self.Icon:SetImage(icon)
end

function PANEL:GetIcon()
   return self.Icon:GetImage()
end

function PANEL:SetIconColor(clr)
   self.Icon:SetImageColor(clr)
end

function PANEL:Think()
   self.animPress:Run()
end

function PANEL:PressedAnim( anim, delta, data )

   if anim.Started then
   end
   
   if anim.Finished then
      self.Icon:StretchToParent( 0, 0, 0, 0 )
      return
   end

   local border = math.sin( delta * math.pi ) * ( self.m_iIconSize * 0.1 )
   self.Icon:StretchToParent( border, border, border, border )

end

vgui.Register( "SimpleIcon", PANEL, "Panel" )




local PANEL = {}

AccessorFunc( PANEL, "AvatarSize",         "AvatarSize" )

function PANEL:Init()
   self.Icon = vgui.Create( "DImage", self )
   self.Icon:SetMouseInputEnabled( false )
   self.Icon:SetKeyboardInputEnabled( false )

   self.imgAvatar = vgui.Create( "AvatarImage", self )
   self.imgAvatar:SetMouseInputEnabled( false )
   self.imgAvatar:SetKeyboardInputEnabled( false )   

   self.animPress = Derma_Anim( "Press", self, self.PressedAnim )
   
   self:SetIconSize(64)

   self:SetAvatarSize(32)

end

function PANEL:PerformLayout()
   local avsz = self:GetAvatarSize()
   self.imgAvatar:SetSize( avsz, avsz )
   self.imgAvatar:Center()

   self:SetSize( self.m_iIconSize, self.m_iIconSize )   
   self.Icon:StretchToParent( 0, 0, 0, 0 )
end

function PANEL:SetPlayer(ply)
   self.imgAvatar:SetPlayer(ply)
end

vgui.Register( "SimpleIconAvatar", PANEL, "SimpleIcon" )




local PANEL = {}

AccessorFunc(PANEL, "IconText", "IconText")

function PANEL:Init()
   self.Icon = vgui.Create( "DImage", self )
   self.Icon:SetMouseInputEnabled( false )
   self.Icon:SetKeyboardInputEnabled( false )

   self:SetIconSize(64)
   self:SetIconText("")

   -- DPanelSelect loves to overwrite its children's PaintOver hooks and such,
   -- so have to use a dummy panel to do some custom painting.
   self.FakeLabel = vgui.Create("Panel", self)
   self.FakeLabel:SetMouseInputEnabled( false )
   self.FakeLabel:SetKeyboardInputEnabled( false )

end

function PANEL:PerformLayout()
   self:SetSize( self.m_iIconSize, self.m_iIconSize )   
   self.Icon:StretchToParent( 0, 0, 0, 0 )

   self.FakeLabel:StretchToParent(0,0,0,0)

   self:SetLabelText(self:GetIconText())
end

function PANEL:SetLabelText(txt)
   if self.FakeLabel then
      local spec = {pos = {32, 32}, color=Color(255,200,0), text=self:GetIconText(), font="TargetID", xalign=TEXT_ALIGN_CENTER, yalign=TEXT_ALIGN_CENTER}
      self.FakeLabel.Paint = function()
                                draw.Text(spec)
                                draw.TextShadow(spec, 2, 255)
                             end
   end
end

vgui.Register("SimpleIconLabelled", PANEL, "SimpleIcon")

